      PROGRAM SEDSIZE
C
C     COMPUTE SIZE STATISTICS FROM PERCENT FINER VALUES
C     Files used: * - read,write, 15(in) - open,read,close,
C                 16(out) - open,write,endfl,close
C
      REAL ab(10), center, cp(10), d(10), d9, dev, devd, dia(33), dmp,
     &     h(10), p1, pctfn(33), probd, s1, sigma, sizdia(33),
     &     sizphi(33), time, tp(10), va(10), x1, x2
      INTEGER i, i1, icd(10), itime, j, m, mp, n9, ncd(10), nf, nn, no,
     &        np, npl, ns, nsamp, ntot, nr, pf, pctcl, pctst, pctsd,
     &        pctgr, prob1, prob4, prob8, in, out, len, len1, lenp1, ios
      CHARACTER*80 loc
      CHARACTER*1 blk, ask, pls, fnt(14)
      CHARACTER*8 fmat(15), kmat(2)
      CHARACTER*10 date
      CHARACTER*80 dfile, ofile
C
      REAL Prob, X, Pct, Phi, Tol
      INTEGER N
      COMMON /CBSTAT/ Prob(307), X(307), Pct(33), Phi(33), Tol, N
C
      REAL FLOAT, SQRT, ALOG10, SIGN, ABS, AINT
      INTEGER INT, NINT
      INTRINSIC FLOAT, INT, SQRT, ALOG10, SIGN, ABS, AINT, NINT
      EXTERNAL INTERP, CLS
C
      DATA cp/1.645, 1.0, 0.6745, 0.3854, 0.0, -0.3854, -0.6745, -1.0, 
     &     -1.282, -1.645/
      DATA tp/5.0, 15.87, 25.0, 35.0, 50.0, 65.0, 75.0, 84.13, 90.0, 
     &     95.0/
      DATA blk, ask, pls/' ', '*', '+'/
      DATA fmat(1), fmat(7), fmat(10), fmat(14)/'(1H+ ', ' ,4X', ' ,4X', 
     &     ' )'/
      DATA kmat/',F8.3,1X', ' ,9X    '/, in/15/, out/16/
C
      loc = 
     $ '$Id: sedsize.f,v 1.9 1997/06/02 18:10:15 rsregan Exp rsregan $'
      ofile = loc(18:32)
      loc = 
     &     '@(#)SEDSIZE - Particle-size statistics of fluvial sediments'
C
C     Clear screen, write title and version
C
      CALL CLS
      WRITE (*,9120) loc(5:60), 'Version: ', ofile(:15)
      loc =
     &  '@(#)SEDSIZE - USGS WRIR 86-4141, H.H. Stevens and D.W. Hubbell'
      loc = '@(#)SEDSIZE - Contact: h2osoft@usgs.gov'
      loc = '@(#)SEDSIZE - Version: 1.9x 1997/06/02'
C
      DO 10 i = 155, 307
        j = 308 - i
        Prob(i) = 100.0 - Prob(j)
   10 CONTINUE
      DO 20 i = 1, 153
        x1 = 3.06 - FLOAT(i-1)*0.02
        X(i) = x1
        X(308-i) = x1
   20 CONTINUE
      X(154) = 0.0
      Tol = 0.001
C
C     Prompt for filenames
C
      WRITE (*,9110) 'size.dat'
      READ (*,9010) dfile
C
C     Create default output name based on input name
C
      IF (dfile.EQ.'    ') dfile = 'SIZE.DAT'
      OPEN (in,FILE=dfile,STATUS='OLD',ACCESS='DIRECT',RECL=80)
      lenp1 = 0
      len = 0
      DO 25 i = 80, 1, -1
        IF (len.EQ.0 .AND. dfile(i:i).NE.' ') len = i
        IF (dfile(i:i).EQ.'.') THEN
          lenp1 = i - 1
          GOTO 26
        END IF
   25 CONTINUE
   26 len1 = len
      IF (len1.GT.3 .AND. len1-lenp1.LT.5) len1 = lenp1
      IF (len1.GT.76) len1 = 76
      lenp1 = len1 + 1
      ofile = dfile
      ofile(lenp1:len1+4) = '.out'
CC    CALL CLS
      WRITE (*,9115) ofile(:len1+4)
      READ (*,9010) loc
      IF (loc.NE.'    ') ofile = loc
C
C     INPUT DATA
C
      OPEN (out,FILE=ofile)
      npl = 100
      nr = 1
      READ (in,REC=nr) nsamp
CC    CALL CLS
      WRITE (*,9005) nsamp, dfile(:len)
      DO 180 ns = 1, nsamp
        nr = nr + 1
Crsr cannot have end of file for direct access
Crsr use IOSTAT to check, <0 usually means error or end of file
Crsr 18446 is end of file for Lahey EM32, 18525 for lf90, 168 for SGI
Crsr    READ (in,REC=nr,ERR=190,END=200) loc
        READ (in,REC=nr,ERR=190,IOSTAT=ios) loc
        IF (ios.LT.0 .OR. ios.EQ.18446 .OR. ios.EQ.168 .OR.
     &      ios.EQ.18525) GOTO 200
        nr = nr + 1
        READ (in,REC=nr,ERR=190,IOSTAT=ios) date, time, no
        IF (ios.LT.0 .OR. ios.EQ.18446 .OR. ios.EQ.168 .OR.
     &      ios.EQ.18525) GOTO 200
        nr = nr + 1
        READ (in,REC=nr,ERR=190,IOSTAT=ios) (sizdia(i),i=1,17)
        IF (ios.LT.0 .OR. ios.EQ.18446 .OR. ios.EQ.168 .OR.
     &      ios.EQ.18525) GOTO 200
        nr = nr + 1
        READ (in,REC=nr,ERR=190,IOSTAT=ios) (sizdia(i),i=18,33)
        IF (ios.LT.0 .OR. ios.EQ.18446 .OR. ios.EQ.168 .OR.
     &      ios.EQ.18525) GOTO 200
        nr = nr + 1
        READ (in,REC=nr,ERR=190,IOSTAT=ios) (pctfn(i),i=1,17)
        IF (ios.LT.0 .OR. ios.EQ.18446 .OR. ios.EQ.168 .OR.
     &      ios.EQ.18525) GOTO 200
        nr = nr + 1
        READ (in,REC=nr,ERR=190,IOSTAT=ios) (pctfn(i),i=18,33)
        IF (ios.LT.0 .OR. ios.EQ.18446 .OR. ios.EQ.168 .OR.
     &      ios.EQ.18525) GOTO 200
        itime = INT(time)
C
C     COMPUTE MEYER-PETER EFFECTIVE DIAMETER
C
        p1 = 0.0
        dmp = 0.0
        IF (pctfn(1).GT.0.0) THEN
          mp = 2
        ELSE
          DO 30 i = 1, no
            IF (pctfn(i+1).GT.0.0) GO TO 40
   30     CONTINUE
   40     s1 = sizdia(i)
          i1 = i + 1
          DO 50 i = i1, no
            IF (pctfn(i).GE.Tol) THEN
              dmp = dmp + SQRT(s1*sizdia(i))*(pctfn(i)-p1)
              s1 = sizdia(i)
              p1 = pctfn(i)
              IF (p1.GE.99.9) THEN
                mp = 1
                dmp = dmp/100.0
                GOTO 60
              ENDIF
            ENDIF
   50     CONTINUE
          mp = 3
        ENDIF
   60   DO 70 i = 1, no
          p1 = -3.322*(ALOG10(sizdia(i)))
          sizphi(i) = INT(p1*10.0+SIGN(0.5,p1))/10.0
   70   CONTINUE
C
C     ELIMINATION OF ZERO PCTFN VALUES
C
        m = 0
        DO 80 i = 1, no
          IF (pctfn(i).GE.Tol) THEN
            m = m + 1
            dia(m) = sizdia(i)
            Pct(m) = pctfn(i)
            Phi(m) = sizphi(i)
          ENDIF
   80   CONTINUE
        i1 = m + 14
        IF (m.LT.10) i1 = 22
        npl = npl + i1
        IF (npl.GT.57) THEN
          npl = i1
          WRITE (out,9060)
        ELSE
          WRITE (out,9070)
        ENDIF
        WRITE (out,9065) loc, date, itime
C
C     COMPUTE STATISTICS
C
        N = 1
        DO 100 i = 1, 10
          icd(i) = 0
   90     IF (tp(i).LE.Pct(N)) THEN
            IF (N.GT.1) THEN
              N = N - 1
            ELSE
C
C     IF STAT. 645 WAS TRUE, INTERPOLATION BETWEEN POINTS. IF FALSE
C     EXTRAPOLATION BELOW GIVEN POINTS
C
              IF (ABS(tp(i)-Pct(N)).GT.Tol) icd(i) = 1
            ENDIF
          ELSEIF (N.LT.m) THEN
            N = N + 1
            GO TO 90
          ELSE
C
C     IF ABOVE STAT. WAS FALSE, EXTRAPOLATION ABOVE GIVEN POINTS
C
            icd(i) = 2
            N = N - 1
          ENDIF
          CALL INTERP(dev,sigma,center)
          IF (dev.LE.0.0) GO TO 170
          pf = INT(tp(i)+0.3)
          h(i) = center + cp(i)*sigma
          IF (h(i).LE.14) THEN
            d(i) = 0.5**h(i)
            IF (m.LT.i) THEN
              WRITE (out,9080) i, pf, h(i), d(i)
            ELSE
              WRITE (out,9075) i, dia(i), Phi(i), Pct(i), pf, h(i), d(i)
            ENDIF
            n9 = icd(i) + 1
            IF (n9.EQ.1) THEN
            ELSEIF (n9.EQ.3) THEN
              WRITE (out,9025) m - 1, m
            ELSE
              WRITE (out,9020)
            ENDIF
          ELSE
            icd(i) = -20
            IF (m.LT.i) THEN
              WRITE (out,9080) i, pf
            ELSE
              WRITE (out,9075) i, dia(i), Phi(i), Pct(i), pf
            ENDIF
            WRITE (out,9015)
          ENDIF
  100   CONTINUE
        IF (m.GT.10) THEN
          DO 110 i = 11, m
            WRITE (out,9075) i, dia(i), Phi(i), Pct(i)
  110     CONTINUE
        ENDIF
C
C     COMPUTE INMAN, TRASK AND FOLK VALUES
C
        ab(1) = 0.5*(h(2)+h(8))
        ab(2) = 0.5*(h(2)-h(8))
        ab(3) = (ab(1)-h(5))/ab(2)
        ab(3) = AINT(ab(3)*100.0)/100.0
        ab(4) = (0.5*(h(10)+h(1))-h(5))/ab(2)
        ab(4) = AINT(ab(4)*100.0)/100.0
        ab(5) = (0.5*(h(1)-h(10))-ab(2))/ab(2)
        ab(6) = (d(7)/d(3))**0.5
        ab(7) = (d(7)*d(3))/(d(5)**2)
        ab(8) = (h(8)+h(5)+h(2))/3.0
        ab(9) = (h(2)-h(8))/4.0 + (h(1)-h(10))/6.6
        x1 = (h(8)+h(2)-2.0*h(5))/(2.0*(h(2)-h(8)))
        x2 = (h(10)+h(1)-2.0*h(5))/(2.0*(h(1)-h(10)))
        ab(10) = x1 + x2
        ncd(1) = icd(2) + icd(8)
        ncd(2) = ncd(1)
        ncd(3) = ncd(1) + icd(5)
        ncd(8) = ncd(3)
        ncd(5) = ncd(1) + icd(1) + icd(10)
        ncd(9) = ncd(5)
        ncd(4) = ncd(5) + icd(5)
        ncd(10) = ncd(4)
        ncd(6) = icd(3) + icd(7)
        ncd(7) = ncd(6) + icd(5)
        ntot = 0
        nf = 1
        np = 0
        DO 120 i = 1, 10
          ntot = ntot + icd(i)
          nf = nf + 1
          IF (ncd(i).GE.0) THEN
            fnt(i) = blk
            IF (ncd(i).GT.0) fnt(i) = ask
            fmat(nf) = kmat(1)
            np = np + 1
            va(np) = ab(i)
          ELSE
            fmat(nf) = kmat(2)
            fnt(i) = pls
          ENDIF
          IF (i.EQ.5 .OR. i.EQ.7) nf = nf + 1
  120   CONTINUE
        WRITE (out,9085) (fnt(i),i=1,10)
        WRITE (out,fmat) (va(i),i=1,np)
C
C     COMPUTATION OF PERCENT CLAY, SILT, SAND, AND GRAVEL
C
        DO 150 nn = 1, 3
          IF (nn.LT.2) THEN
            IF (Phi(m).GT.-1.0) THEN
              probd = 100.0
              GO TO 150
            ELSE
              d9 = -1.0
              N = 1
            ENDIF
          ELSEIF (nn.EQ.2) THEN
            prob1 = NINT(probd)
            d9 = 4.0
            N = 1
          ELSE
            prob4 = NINT(probd)
            IF (m.EQ.1) THEN
              pctcl = 0
              pctst = prob4
              pctsd = prob1 - prob4
              pctgr = 100 - prob1
              GO TO 160
            ELSE
              d9 = 8.0
              N = 1
            END IF
          END IF
  130     IF (d9.LT.Phi(N)) THEN
            IF (N.GE.m) THEN
              N = N - 1
            ELSE
              N = N + 1
              GO TO 130
            END IF
          ELSE IF (d9.EQ.Phi(N)) THEN
            probd = Pct(N)
            GO TO 150
          ELSE IF (N.NE.1) THEN
            N = N - 1
          END IF
          CALL INTERP(dev,sigma,center)
          IF (dev.LE.0.0) GO TO 170
          IF (d9.LT.center) THEN
            devd = (center-d9)/sigma
            IF (devd.GT.3.06) THEN
              probd = 100.0
              GO TO 150
            ELSE
              N = 154
  135         IF (devd.LT.X(N)) THEN
              ELSE IF (devd.EQ.X(N)) THEN
                probd = Prob(N)
                GO TO 150
              ELSE
                N = N + 1
                GO TO 135
              ENDIF
            ENDIF
          ELSEIF (d9.EQ.center) THEN
            probd = 50.0
            GO TO 150
          ELSE
            devd = (d9-center)/sigma
            IF (devd.GT.3.06) THEN
              probd = 0.0
              GO TO 150
            ELSE
              N = 1
  140         IF (devd.LT.X(N)) THEN
                N = N + 1
                GO TO 140
              ELSE IF (devd.EQ.X(N)) THEN
                probd = Prob(N)
                GO TO 150
              ENDIF
            ENDIF
          ENDIF
          probd = Prob(N-1) + (devd-X(N-1))*(Prob(N)-Prob(N-1))/0.02
  150   CONTINUE
        prob8 = NINT(probd)
        pctcl = prob8
        pctst = prob4 - prob8
        pctsd = prob1 - prob4
        pctgr = 100 - prob1
  160   fnt(11) = blk
        IF (pctgr.NE.0) THEN
          IF (Phi(m).GT.-1.0 .AND. ABS(Pct(m)-99.9).GE.Tol) THEN
            fnt(11) = ask
            ntot = ntot + 1
          END IF
        END IF
        fnt(12) = blk
        IF (pctsd.NE.0) THEN
          IF (.NOT.(Phi(m).LE.-1.0.OR.ABS(Pct(m)-99.9).LT.Tol.AND.Phi(1)
     &        .GT.4.0.OR.ABS(Pct(1)-0.1).LT.Tol)) THEN
            fnt(12) = ask
            ntot = ntot + 1
          END IF
        END IF
        fnt(13) = blk
        IF (pctst.NE.0) THEN
          IF (.NOT.(Phi(m).GT.4.0.OR.ABS(Pct(m)-99.9).LT.Tol.AND.Phi(1)
     &        .GT.8.0.OR.ABS(Pct(1)-0.1).LT.Tol)) THEN
            fnt(13) = ask
            ntot = ntot + 1
          END IF
        END IF
        fnt(14) = blk
        IF (pctcl.NE.0) THEN
          IF (Phi(1).LE.8.0 .AND. ABS(Pct(1)-0.1).GE.Tol) THEN
            fnt(14) = ask
            ntot = ntot + 1
          END IF
        END IF
        IF (mp.EQ.2) THEN
          WRITE (out,9035)
        ELSE IF (mp.EQ.3) THEN
          WRITE (out,9040)
        ELSE
          WRITE (out,9030) dmp
        END IF
        WRITE (out,9045) pctgr, fnt(11), pctsd, fnt(12), pctst, fnt(13), 
     &                 pctcl, fnt(14)
        IF (ntot.NE.0) THEN
          WRITE (out,9050)
          IF (ntot.LT.0) WRITE (out,9055)
        END IF
        GO TO 180
  170   WRITE (out,9090)
        WRITE (out,9050)
  180 CONTINUE
      GO TO 210
  190 WRITE (out,9100) dfile(:len)
      GO TO 210
  200 WRITE (out,9105) dfile(:len)
  210 END FILE (out)
      CLOSE (in)
      CLOSE (out)
      WRITE (*,9095) ofile
      STOP
C
 9005 FORMAT (//,' Computed size statistics for',I3,
     &        ' data sets read from file:',/,1X,A)
 9010 FORMAT (A)
 9015 FORMAT ('+',58X,'-- UNDEFINED')
 9020 FORMAT ('+',58X,'-- EXTRAPOLATED FROM POINTS  1 AND  2')
 9025 FORMAT ('+',58X,'-- EXTRAPOLATED FROM POINTS',I3,' AND',I3)
 9030 FORMAT (/,' PCT GRAVEL   PCT SAND     PCT SILT     PCT CLAY',10X,
     &        'MEYER-PETER EFFECTIVE DIAMETER IS 'F8.3,' MM')
 9035 FORMAT (/,' PCT GRAVEL   PCT SAND     PCT SILT     PCT CLAY',10X,
     &'MEYER-PETER EFF. DIAM. NOT COMPUTED - 0% FINER SIZE NOT DEFINED')
 9040 FORMAT (/,' PCT GRAVEL   PCT SAND     PCT SILT     PCT CLAY',10X,
     &'MEYER-PETER EFF. DIAM. NOT COMPUTED - 100% FINER SIZE NOT DEFINED
     &')
 9045 FORMAT (1X,I5,A1,9X,I3,A1,9X,I3,A1,9X,I3,A1)
 9050 FORMAT (/,11X,'* BASED ON EXTRAPOLATED VALUES - MAY BE IN ERROR')
 9055 FORMAT ('+',60X,'+ UNDEFINED')
 9060 FORMAT (1X,13('+++++++++'))
 9065 FORMAT (/,' SIZE STATISTICS FOR ',A80,5X,A10,I6,/,
     &       ' NO     DIA     PHI    P.F.',11X,'P.F.     PHI     DIA',/)
 9070 FORMAT (/,1X,13('---------'))
 9075 FORMAT (1X,I2,2F8.3,F8.1,10X,I5,2F8.3)
 9080 FORMAT (1X,I2,34X,I5,2F8.3)
 9085 FORMAT (/,19X,'INMAN VALUES',24X,'TRASK VALUES',14X,'FOLK VALUES',
     &        /,5X,'MEAN     SORT    ALPH1    ALPH2     BETA',9X,
     &        'SORT     SKEW',9X,'MEAN     SORT     SKEW',/,1X,5(8X,A1),
     &        4X,2(8X,A1),4X,3(8X,A1))
 9090 FORMAT (/,' *** DEV = 0   INPUT DATA IN ERROR ***'/'0')
 9095 FORMAT (/,' Output is found in file ',A,///,
     &        ' *** END OF RUN ***',//)
 9100 FORMAT (/,' *** READ ERROR ON FILE ',A,' ***')
 9105 FORMAT (/,' *** END-OF-FILE ON FILE ',A,' ***')
 9110 FORMAT (//,' Establish file names:',//,
     &        ' Enter name of size-distribution data file, (default = ',
     &        A,'):  ')
 9115 FORMAT (/,' Enter name of output file,',/,' (default = ',A,'):  ')
 9120 FORMAT (7X,A,/,23X,2A)
      END
C
C
C
      BLOCK DATA BLSEDSIZE
      REAL Prob, X, Pct, Phi, Tol
      INTEGER N, i
      COMMON /CBSTAT/ Prob(307), X(307), Pct(33), Phi(33), Tol, N
      DATA (Prob(i),i=1,154)/0.10, 0.11, 0.12, 0.13, 0.14, 0.15, 0.16,
     &      0.18, 0.19, 0.20, 0.21, 0.23, 0.24, 0.26, 0.27, 0.29, 0.31,
     &      0.33, 0.35, 0.37, 0.39, 0.41, 0.44, 0.47, 0.49, 0.52, 0.55,
     &      0.59, 0.62, 0.66, 0.69, 0.73, 0.78, 0.82, 0.87, 0.91, 0.96,
     &      1.02, 1.07, 1.13, 1.19, 1.25, 1.32, 1.39, 1.46, 1.54, 1.62,
     &      1.70, 1.79, 1.88, 1.97, 2.07, 2.17, 2.28, 2.39, 2.50, 2.62,
     &      2.74, 2.87, 3.01, 3.14, 3.29, 3.44, 3.59, 3.75, 3.92, 4.09,
     &      4.27, 4.46, 4.65, 4.85, 5.05, 5.26, 5.48, 5.71, 5.94, 6.18,
     &      6.43, 6.68, 6.94, 7.21, 7.49, 7.78, 8.08, 8.38, 8.69, 9.01,
     &      9.34, 9.68, 10.03, 10.38, 10.75, 11.12, 11.51, 11.90, 12.30,
     &      12.71, 13.14, 13.57, 14.01, 14.46, 14.92, 15.39, 15.87,
     &      16.35, 16.85, 17.36, 17.88, 18.41, 18.94, 19.49, 20.05,
     &      20.61, 21.19, 21.77, 22.36, 22.97, 23.58, 24.20, 24.83,
     &      25.46, 26.11, 26.76, 27.43, 28.10, 28.77, 29.46, 30.15,
     &      30.85, 31.56, 32.28, 33.00, 33.72, 34.46, 35.20, 35.94,
     &      36.69, 37.45, 38.21, 38.97, 39.74, 40.52, 41.29, 42.07,
     &      42.86, 43.64, 44.43, 45.22, 46.02, 46.81, 47.61, 48.40,
     &      49.20, 50.00/
      END
C
C
C
      SUBROUTINE INTERP(DEV,SIGMA,CENTER)
      REAL CENTER, DEV, dev1, dev2, SIGMA
      INTEGER j, j1, j2, j3, j4, j5
C
      REAL Prob, X, Pct, Phi, Tol
      INTEGER N
      COMMON /CBSTAT/ Prob(307), X(307), Pct(33), Phi(33), Tol, N
C
      IF (Pct(N).GE.50.0) THEN
        j = 154
   10   IF (Prob(j).GE.Pct(N)) THEN
          dev1 = X(j-1) + ((Pct(N)-Prob(j-1))*0.02/(Prob(j)-Prob(j-1)))
        ELSE
          j = j + 1
          GO TO 10
        END IF
      ELSE
        j = 1
   20   IF (Prob(j).LT.Pct(N)) THEN
          j = j + 1
          GO TO 20
        ELSE IF (Pct(N).GT.0.1) THEN
          dev1 = X(j-1) - ((Pct(N)-Prob(j-1))*0.02/(Prob(j)-Prob(j-1)))
        ELSE
          dev1 = X(1)
        END IF
      END IF
      j1 = j
      IF (Pct(N+1).GE.50.0) THEN
        j = 154
   30   IF (Prob(j).GE.Pct(N+1)) THEN
          dev2 = X(j-1) + ((Pct(N+1)-Prob(j-1))*0.02/(Prob(j)-Prob(j-1))
     &           )
        ELSE
          j = j + 1
          GO TO 30
        END IF
      ELSE
        j = 1
   40   IF (Prob(j).GE.Pct(N+1)) THEN
          dev2 = X(j-1) - ((Pct(N+1)-Prob(j-1))*0.02/(Prob(j)-Prob(j-1))
     &           )
        ELSE
          j = j + 1
          GO TO 40
        END IF
      END IF
      j2 = j
      j3 = 1
      j4 = 1
      IF (j1.LE.154) j3 = -1
      IF (j2.LE.154) j4 = -1
      j5 = j3 + j4 + 3
      IF (j5.LT.3) THEN
C
C     CENTER IS BELOW BOTH POINTS
C
        DEV = dev1 - dev2
      ELSE IF (j5.EQ.3) THEN
C
C     CENTER IS BETWEEN POINTS
C
        DEV = dev1 + dev2
      ELSE
C
C     CENTER IS ABOVE BOTH POINTS
C
        DEV = dev2 - dev1
        IF (DEV.LT.Tol) RETURN
        SIGMA = (Phi(N)-Phi(N+1))/DEV
        CENTER = Phi(N) + dev1*SIGMA
        RETURN
      END IF
      IF (DEV.LT.Tol) RETURN
      SIGMA = (Phi(N)-Phi(N+1))/DEV
      CENTER = Phi(N) - dev1*SIGMA
      RETURN
      END
C
C
C
      SUBROUTINE CLS
C
C The screen is cleared.  Works for VT100
C
      CHARACTER*1 esc
      INTRINSIC CHAR
      esc = CHAR(27)
      WRITE (*,*) esc//'[2J'//esc//'[H'
      RETURN
      END
