      PROGRAM SIZEDATA
C
C     ENTER DATA FOR SEDSIZE PROGRAM TO INPUT FILE SIZE.DATA OR
C          USER SPECIFIED FILE
C     File used: * - read,write, 10(lunit) - open,read,write,close,
C                11(list) - open,write,endfl,close
C
      REAL p1, p2, pinc, pmax, pmin
      INTEGER i, inopt, ist, j, joptn, n, n1, n2, nc, ninc, nmax, nmin, 
     &        ns, ns1, ns2, nsamp, lunit, list, len
      CHARACTER*80 sta, dfile
C
      REAL Time, Diam, Sizdia, Pctfn, Size
      INTEGER Nrec, No
      COMMON /AA    / Time, Diam(33), Sizdia(33), Pctfn(33), 
     &                Size(33), Nrec, No
      CHARACTER Loc*80, vers*15
      CHARACTER*10 Date
      COMMON /CAA   / Loc, Date
C
      INTEGER INT, LENS
      INTRINSIC INT
      EXTERNAL CLSCR, DAREAD, DACORR, DAWRITE, DALIST, TABLE, CLS, LENS
C
C     Assign logical unit numbers
      lunit = 10
      list = 11
C
C     Set RCS ident and UNIX what strings
      sta =
     $'$Id: sizedata.f,v 1.10 1997/06/02 18:14:10 rsregan Exp rsregan $'
      vers = sta(18:33)
      sta =
     &  '@(#)SIZEDATA - Data entry for sediment size statistics program'
C
C     Clear screen, write title and version
      CALL CLS
      WRITE (*,9115) sta(5:62), 'VERSION:', vers
      sta =
     &'@(#)SIZEDATA - USGS WRIR 86-4141, H.H. Stevens and D.W. Hubbell'
      sta = '@(#)SIZEDATA - Contact: h2osoft@usgs.gov'
      sta = '@(#)SIZEDATA - Version: 1.10x 1997/06/02'
C
C     Prompt for filename
C
      WRITE (*,9110) 'size.dat'
      READ (*,9020) dfile
      IF (dfile.EQ.'    ') dfile = 'size.dat'
      len = LENS(dfile)
C
      CALL CLS
   3  WRITE (*,9085) dfile(:len), dfile(:len), dfile(:len), dfile(:len),
     &               dfile(:len)
      WRITE (*,9010)
      READ (*,*) nc
      IF (nc.LT.1 .OR. nc.GT.5) THEN
        WRITE (*,*) '*** Invalid response ***'
        CALL CLSCR(3)
        GO TO 3
      END IF
      IF (nc.EQ.1) THEN
C START NEW SET of DATA
        OPEN (lunit,FILE=dfile,STATUS='NEW',ACCESS='DIRECT',RECL=80)
        nsamp = 0
        Nrec = 1
      ELSE
        OPEN (lunit,FILE=dfile,STATUS='OLD',ACCESS='DIRECT',RECL=80)
        READ (lunit,REC=1) nsamp
        IF (nc.EQ.2) THEN
C nc=2 ADD DATA TO EXISTING FILE
          Nrec = nsamp*6 + 1
        ELSE IF (nc.EQ.3) THEN
C nc=3 CORRECT DATA
    5     CALL CLS
          WRITE (*,*)
     &             'Enter data number to be corrected (0 to end run):  '
          READ (*,*) ns
          IF (ns.EQ.0) GO TO 240
          IF (ns.LE.nsamp) THEN
            Nrec = (ns-1)*6 + 1
            CALL DAREAD(lunit)
            CALL DACORR(ns)
            Nrec = (ns-1)*6 + 1
            CALL DAWRITE(lunit)
          END IF
          GO TO 5
        ELSEIF (nc.EQ.4) THEN
C nc=4 LIST ON SCREEN
   10     CALL CLS
          WRITE (*,9065)
          READ (*,*) ns1
          IF (ns1.EQ.0) GO TO 250
          IF (ns1.GT.nsamp) GO TO 10
          Nrec = (ns1-1)*6 + 1
   20     WRITE (*,9070) nsamp
          READ (*,*) ns2
          IF (ns2.GT.nsamp) GO TO 20
          DO 30 ns = ns1, ns2
            CALL DAREAD(lunit)
            CALL DALIST(ns)
            WRITE (*,9105)
            READ (*,*)
   30     CONTINUE
          GO TO 10
        ELSE IF (nc.EQ.5) THEN
C nc=5 LIST DATA ON PRINT FILE SIZEDATA.OUT
          OPEN (list,FILE='sizedata.out',STATUS='NEW')
          WRITE (list,9025) dfile
   40     CALL CLS
          WRITE (*,9075)
          READ (*,*) ns1
          IF (ns1.EQ.0) THEN
            ENDFILE (list)
            CLOSE (list)
            GO TO 250
          ELSE
            IF (ns1.GT.nsamp) GO TO 40
            Nrec = (ns1-1)*6 + 1
   50       CALL CLSCR(3)
            WRITE (*,9080) nsamp
            READ (*,*) ns2
            IF (ns2.GT.nsamp) GO TO 50
            DO 60 ns = ns1, ns2
              CALL DAREAD(lunit)
              WRITE (list,9035) ns, Loc(:LENS(Loc))
              WRITE (list,9040) ns, Date, Time, No
              WRITE (list,9045) ns, (Size(n),n=1,No)
              WRITE (list,9060) ns, (Pctfn(n),n=1,No)
   60       CONTINUE
            GO TO 40
          END IF
        END IF
      END IF
C Here for nc = 1 or 2
   70 ist = 0
      CALL CLS
      WRITE (*,9120)
      WRITE (*,9010)
      READ (*,*) inopt
      IF (inopt.GT.5) GO TO 70
      IF (inopt.EQ.5) THEN
        CALL TABLE
        WRITE (*,9105)
        READ (*,*)
        GO TO 70
      ELSEIF (inopt.EQ.2) THEN
   80   CALL TABLE
        WRITE (*,*) 'Enter min table diameter no.:  '
        READ (*,*) nmin
        IF (nmin.LT.1) GO TO 80
   90   WRITE (*,*) ' '
        WRITE (*,*) 'Enter max table diameter no.:  '
        READ (*,*) nmax
        IF (nmax.GT.33) GO TO 90
        WRITE (*,*) ' '
        WRITE (*,*) 'Enter increment (i.e. 2 = every other diameter):  '
        READ (*,*) ninc
        No = 0
        DO 100 j = nmin, nmax, ninc
          No = No + 1
          IF (No.GT.33) THEN
            WRITE (*,*) '**** Number of diameters > 33 ****'
            WRITE (*,9105)
            READ (*,*)
            GO TO 80
          ELSE
            Sizdia(No) = Diam(j)
          END IF
  100   CONTINUE
      ELSE IF (inopt.EQ.3) THEN
  110   CALL CLS
        WRITE (*,*) 'Enter number of sizes to be entered (max=33):  '
        READ (*,*) No
        IF (No.GT.33) GO TO 110
        DO 120 i = 1, No
          CALL CLSCR(3)
          WRITE (*,9055) i
          READ (*,*) Sizdia(i)
  120   CONTINUE
      ELSE IF (inopt.EQ.4) THEN
  130   CALL TABLE
        WRITE (*,*) 'Enter max phi value:  '
        READ (*,*) pmax
        CALL CLSCR(3)
        WRITE (*,*) 'Enter min phi value:  '
        READ (*,*) pmin
        CALL CLSCR(3)
        WRITE (*,*) 'Enter phi increment (1.0 or 0.5):  '
        READ (*,*) pinc
        CALL CLSCR(3)
        No = INT((pmax-pmin)/pinc+1.0)
        IF (No.LE.33) THEN
          p1 = pmax
          Sizdia(1) = 0.5**p1
          DO 140 i = 2, No
            p2 = p1 - pinc
            Sizdia(i) = 0.5**p2
            p1 = p2
  140     CONTINUE
        ELSE
          WRITE (*,*) '**** Number of diameters > 33 ****'
          WRITE (*,9105)
          READ (*,*)
          GO TO 130
        END IF
      ELSE
  150   CALL CLS
        WRITE (*,*) 'Enter number diameters to be used (max=33):  '
        READ (*,*) No
        IF (No.GT.33) GO TO 150
        DO 170 i = 1, No
  160     CALL TABLE
          CALL CLSCR(3)
          WRITE (*,9050) i
          READ (*,*) j
          IF (j.GT.33) GO TO 160
          Sizdia(i) = Diam(j)
  170   CONTINUE
      END IF
      CALL CLS
      n1 = -9
  180 n1 = n1 + 10
      n2 = n1 + 9
      IF (n2.GT.No) n2 = No
      WRITE (*,9090) (n,n=n1,n2)
      WRITE (*,9095) (Sizdia(n),n=n1,n2)
      WRITE (*,*) '              '
      IF (n2.LT.No) GO TO 180
      CALL CLSCR(3)
      WRITE (*,*) 'Are diameters ok? (1=YES, 2=NO):  '
      READ (*,*) n
      IF (n.GT.1) GO TO 70
  190 CALL CLS
      WRITE (*,*) 'Enter station description (max=80 characters):  '
      READ (*,9020) sta
      IF (ist.EQ.0) GO TO 205
      ist = ist + 1
  200 CALL CLS
      WRITE (*,9125)
      WRITE (*,9010)
      READ (*,*) joptn
      IF (joptn.GT.4) GO TO 200
      IF (joptn.EQ.2) GO TO 190
      IF (joptn.EQ.3) GO TO 70
      IF (joptn.EQ.4) GO TO 240
  205 nsamp = nsamp + 1
  210 CALL CLS
      WRITE (*,9030) nsamp
      Loc = sta
      WRITE (*,9020) Loc(:LENS(sta))
      WRITE (*,*) ' '
      WRITE (*,*) 'Enter data (mm/dd/yy):  '
      READ (*,9020) Date
      CALL CLSCR(2)
      WRITE (*,*) 'Enter time (2400 hr):  '
      READ (*,*) Time
      DO 220 i = 1, 33
        Size(i) = 0
        Pctfn(i) = 0
  220 CONTINUE
      DO 230 i = 1, No
        Size(i) = Sizdia(i)
        WRITE (*,*) ' '
        WRITE (*,9005) Sizdia(i)
        READ (*,*) Pctfn(i)
  230 CONTINUE
      CALL DALIST(nsamp)
      WRITE (*,9130)
      WRITE (*,9010)
      READ (*,*) i
      IF (i.EQ.2) GO TO 210
      IF (i.NE.1) THEN
        CALL DACORR(nsamp)
      END IF
      CALL DAWRITE(lunit)
      GO TO 200
C
  240 CALL CLS
      WRITE (*,9015) nsamp
      WRITE (lunit,REC=1) nsamp
      WRITE (*,9100) dfile
      WRITE (*,*) ' '
  250 CLOSE (lunit)
      CALL CLSCR(5)
      WRITE (*,*) 'End of run'
      CALL CLSCR(5)
      STOP
 9005 FORMAT (' Enter percent-finer value for',F9.3,':  ')
 9010 FORMAT (//,' Enter number of selection:  ')
 9015 FORMAT (' Number data sets =',I5)
 9020 FORMAT (A)
 9025 FORMAT ('1Data stored in file  ',A20)
 9030 FORMAT (' Data set number',I34/)
 9035 FORMAT (/,I4,3X,A)
 9040 FORMAT (I4,3X,A10,F5.0,I4)
 9045 FORMAT (I4,3X,15F8.3,/,(7X,15F8.3))
 9050 FORMAT (' Enter table number for diameter no.',I4,':  ')
 9055 FORMAT (' Enter diameter in mm (include decimal) size no.',I4,
     &        ':  ')
 9060 FORMAT (I4,3X,15F8.1,/,(7X,15F8.1))
 9065 FORMAT (' Enter start set number to be listed (0 to end run):  ')
 9070 FORMAT (//,' Enter end set number to be listed (max =',I4,'):  ')
 9075 FORMAT (' Enter start set number to be printed (0 to end run):  ')
 9080 FORMAT (' Enter end set number to be printed (max =',I4,'):  ')
 9085 FORMAT (6X,'1. Start data entry into ',A,/,6X,'2. Add data to ',A,
     &        /,6X,'3. Correct data in ',A,/,6X,'4. Display data in ',A,
     &        /,6X,'5. Print data in ',A)
 9090 FORMAT (10I8)
 9095 FORMAT (10F8.3)
 9100 FORMAT (' Data stored in file  ',A)
 9105 FORMAT (/,' Enter to continue')
 9110 FORMAT (//,' Establish file name:',//,
     &        ' Enter name of size-distribution data file, (default = ',
     &        A,'):  ')
 9115 FORMAT (7X,A,/,23X,2A)
 9120 FORMAT (' Method of entering particle diameters:',//,6X,
     &        '1. Individual diameter numbers form size table',/,6X,
     &        '2. Sequential diameters between min-max table numbers',/,
     &        6X,'3. Individually entered diameters (in mm)',/,
     &        6X,'4. Sequential phi values between min-max values',/,6X,
     &        '5. Show size table')
 9125 FORMAT (' Requirement for next data-set entry:',//,6X,
     &        '1. Same station description and diameters',/,6X,
     &        '2. New station description, same diameters',/,6X,
     &        '3. New station description and particle diameters',/,6X,
     &        '4. End run')
 9130 FORMAT (/,6X,'1. Data set ok',/,6X,'2. Re-enter complete data set'
     &        ,/,6X,'3. Correct part of data set')
 
      END
C
C
C
      BLOCK DATA BLSIZEDATA
      REAL Time, Diam, Sizdia, Pctfn, Size
      INTEGER Nrec, No
      COMMON /AA    / Time, Diam(33), Sizdia(33), Pctfn(33), 
     &                Size(33), Nrec, No
      DATA Diam/0.002, 0.003, 0.004, 0.006, 0.008, 0.011, 0.016, 0.022, 
     &     0.031, 0.044, 0.062, 0.088, 0.125, 0.177, 0.250, 0.354, 
     &     0.500, 0.707, 1.0, 1.4, 2.0, 2.8, 4.0, 5.6, 8.0, 11.3, 16.0, 
     &     22.6, 32.0, 45.2, 64.0, 90.5, 128.0/
      END
C
C
C
      SUBROUTINE DAWRITE(LUNIT)
C
C     WRITE ONE SET OF DATA TO FILE
C     File used: 10(LUNIT) - write
C
      INTEGER i, LUNIT
C
      REAL Time, Diam, Sizdia, Pctfn, Size
      INTEGER Nrec, No
      COMMON /AA    / Time, Diam(33), Sizdia(33), Pctfn(33), 
     &                Size(33), Nrec, No
      CHARACTER*80 Loc
      CHARACTER*10 Date
      COMMON /CAA   / Loc, Date
C
      Nrec = Nrec + 1
      WRITE (LUNIT,REC=Nrec) Loc
      Nrec = Nrec + 1
      WRITE (LUNIT,REC=Nrec) Date, Time, No
      Nrec = Nrec + 1
      WRITE (LUNIT,REC=Nrec) (Size(i),i=1,17)
      Nrec = Nrec + 1
      WRITE (LUNIT,REC=Nrec) (Size(i),i=18,33)
      Nrec = Nrec + 1
      WRITE (LUNIT,REC=Nrec) (Pctfn(i),i=1,17)
      Nrec = Nrec + 1
      WRITE (LUNIT,REC=Nrec) (Pctfn(i),i=18,33)
      RETURN
      END
C
C
C
      SUBROUTINE DAREAD(LUNIT)
C
C     READ ONE SET OF DATA FROM FILE
C     File used: 10(LUNIT) - read,close, * - write
C
      INTEGER i, ios, LUNIT
C
      REAL Time, Diam, Sizdia, Pctfn, Size
      INTEGER Nrec, No
      COMMON /AA    / Time, Diam(33), Sizdia(33), Pctfn(33), 
     &                Size(33), Nrec, No
      CHARACTER*80 Loc
      CHARACTER*10 Date
      COMMON /CAA   / Loc, Date
C
      Nrec = Nrec + 1
Crsr cannot have end of file for direct access
Crsr use IOSTAT to check, <0 usually means error or end of file
Crsr 18446 is end of file for Lahey EM32, 18525 for lf90, 168 for SGI
Crsr  READ (LUNIT,REC=Nrec,ERR=10,END=20) Loc
      READ (LUNIT,REC=Nrec,ERR=10,IOSTAT=ios) Loc
      IF (ios.LT.0 .OR. ios.EQ.18446 .OR. ios.EQ.168 .OR.
     &    ios.EQ.18525) GOTO 20
      READ (LUNIT,REC=Nrec,ERR=10,IOSTAT=ios) Loc
      IF (ios.LT.0 .OR. ios.EQ.18446 .OR. ios.EQ.168 .OR.
     &    ios.EQ.18525) GOTO 20
      Nrec = Nrec + 1
      READ (LUNIT,REC=Nrec,ERR=10,IOSTAT=ios) Date, Time, No
      IF (ios.LT.0 .OR. ios.EQ.18446 .OR. ios.EQ.168 .OR.
     &    ios.EQ.18525) GOTO 20
      Nrec = Nrec + 1
      READ (LUNIT,REC=Nrec,ERR=10,IOSTAT=ios) (Size(i),i=1,17)
      IF (ios.LT.0 .OR. ios.EQ.18446 .OR. ios.EQ.168 .OR.
     &    ios.EQ.18525) GOTO 20
      Nrec = Nrec + 1
      READ (LUNIT,REC=Nrec,ERR=10,IOSTAT=ios) (Size(i),i=18,33)
      IF (ios.LT.0 .OR. ios.EQ.18446 .OR. ios.EQ.168 .OR.
     &    ios.EQ.18525) GOTO 20
      Nrec = Nrec + 1
      READ (LUNIT,REC=Nrec,ERR=10,IOSTAT=ios) (Pctfn(i),i=1,17)
      IF (ios.LT.0 .OR. ios.EQ.18446 .OR. ios.EQ.168 .OR.
     &    ios.EQ.18525) GOTO 20
      Nrec = Nrec + 1
      READ (LUNIT,REC=Nrec,ERR=10,IOSTAT=ios) (Pctfn(i),i=18,33)
      IF (ios.LT.0 .OR. ios.EQ.18446 .OR. ios.EQ.168 .OR.
     &    ios.EQ.18525) GOTO 20
      RETURN
   10 WRITE (*,*) 'ENDING WITH READ ERROR'
      GO TO 30
   20 WRITE (*,*) 'STOPPED AT END-OF-FILE'
   30 CLOSE (LUNIT)
      STOP
      END
C
C
C
      SUBROUTINE DACORR(NSAMP)
C
C     CORRECT ONE SET OF DATA
C     Files used: * - read,write
C
      INTEGER i, n, NSAMP
C
      REAL Time, Diam, Sizdia, Pctfn, Size
      INTEGER Nrec, No
      COMMON /AA    / Time, Diam(33), Sizdia(33), Pctfn(33), 
     &                Size(33), Nrec, No
      CHARACTER*80 Loc
      CHARACTER*10 Date
      COMMON /CAA   / Loc, Date
C
      INTEGER LENS
      EXTERNAL DALIST, LENS
C
   10 CALL DALIST(NSAMP)
      WRITE (*,9040)
      WRITE (*,*) 'Enter number of selection:  '
      READ (*,*) i
      IF (i.EQ.0) RETURN
      IF (i.EQ.2) THEN
        WRITE (*,9010) Date
        READ (*,9015) Date
      ELSE IF (i.EQ.3) THEN
        WRITE (*,9020) Time
        READ (*,*) Time
      ELSE IF (i.EQ.4) THEN
   20   WRITE (*,9025) No
        READ (*,*) n
        IF (n.NE.0) THEN
          IF (n.LE.No) THEN
            WRITE (*,9030) Size(n)
            READ (*,*) Size(n)
          END IF
          GO TO 20
        END IF
      ELSE IF (i.EQ.5) THEN
   30   WRITE (*,9025) No
        READ (*,*) n
        IF (n.NE.0) THEN
          IF (n.LE.No) THEN
            WRITE (*,9035) Pctfn(n)
            READ (*,*) Pctfn(n)
          END IF
          GO TO 30
        END IF
      ELSE IF (i.EQ.1) THEN
        WRITE (*,9045)
        n = LENS(Loc)
        WRITE (*,9005) Loc(:n)
        READ (*,9005) Loc(:n)
      END IF
      GO TO 10
 9005 FORMAT (A)
 9010 FORMAT (/,' Enter new date to replace ',A10,':  ')
 9015 FORMAT (A10)
 9020 FORMAT (/,' Enter new time to replace',F6.0,':  ')
 9025 FORMAT (/,' Enter size number  max=',I4,'  (0 to end run):  ')
 9030 FORMAT (/,' Enter new diameter value to replace',F9.3,':  ')
 9035 FORMAT (/,' Enter new percent finer value to replace',F7.1,':  ')
 9040 FORMAT (/,' 0. All corrections completed      3. Change time',/,
     &   ' 1. Change station description     4. Change diameter values',
     &   /,' 2. Change date',20X,'5. Change percent-finer values',/)
 9045 FORMAT (/,' Enter new location to replace:  ')
      END
C
C
C
      SUBROUTINE DALIST(NSAMP)
C
C     LIST ONE SET OF DATA ON SCREEN
C     Files used: * - write
C
      INTEGER n, n1, n2, NSAMP
C
      REAL Time, Diam, Sizdia, Pctfn, Size
      INTEGER Nrec, No
      COMMON /AA    / Time, Diam(33), Sizdia(33), Pctfn(33), 
     &                Size(33), Nrec, No
      CHARACTER*80 Loc
      CHARACTER*10 Date
      COMMON /CAA   / Loc, Date
C
      INTEGER LENS
      EXTERNAL CLS, LENS
C
      CALL CLS
      WRITE (*,9005) NSAMP, Loc(:LENS(Loc))
      WRITE (*,9010) Date, Time, No
      n1 = -9
   10 n1 = n1 + 10
      n2 = n1 + 9
      IF (n2.GT.No) n2 = No
      WRITE (*,9020) (n,n=n1,n2)
      WRITE (*,9025) (Size(n),n=n1,n2)
      WRITE (*,9030) (Pctfn(n),n=n1,n2)
      WRITE (*,*) '         '
      IF (n2.LT.No) GO TO 10
      RETURN
 9005 FORMAT ('Data set number',I4,/,A)
 9010 FORMAT (/,'DATE  ',A10,5X,'TIME',F7.0,5X,'NO. SIZES =',I5,/)
 9020 FORMAT (10I8)
 9025 FORMAT (10F8.3)
 9030 FORMAT (10F8.1)
      END
C
C
C
      SUBROUTINE TABLE
C
C     LIST SIZE TABLE ON SCREEN
C     Files used: * - write
C
      EXTERNAL CLS
C
      CALL CLS
      WRITE (*,9005)
      RETURN
C
 9005 FORMAT (' Size table showing number, diameter & phi units',//,
     &      '  NO   DIAM   PHI    NO   DIAM   PHI    NO   DIAM   PHI',/,
     &      '   1  0.002   9.0    12  0.088   3.5    23    4.0  -2.0',/,
     &      '   2  0.003   8.5    13  0.125   3.0    24    5.6  -2.5',/,
     &      '   3  0.004   8.0    14  0.177   2.5    25    8.0  -3.0',/,
     &      '   4  0.006   7.5    15  0.250   2.0    26   11.3  -3.5',/,
     &      '   5  0.008   7.0    16  0.354   1.5    27   16.0  -4.0',/,
     &      '   6  0.011   6.5    17  0.500   1.0    28   22.6  -4.5',/,
     &      '   7  0.016   6.0    18  0.707   0.5    29   32.0  -5.0',/,
     &      '   8  0.022   5.5    19  1.0     0.0    30   45.2  -5.5',/,
     &      '   9  0.031   5.0    20  1.4    -0.5    31   64.0  -6.0',/,
     &      '  10  0.044   4.5    21  2.0    -1.0    32   90.5  -6.5',/,
     &      '  11  0.062   4.0    22  2.8    -1.5    33  128.0  -7.0',/)
      END
C
C
C
      SUBROUTINE CLSCR(N)
C
C     MOVE CURSOR DOWN N LINES
C     Files used: * - write
C
      INTEGER i, N
C
      DO 10 i = 1, N
        WRITE (*,*) ' '
   10 CONTINUE
      RETURN
      END
C
C
C
      SUBROUTINE CLS
C
C The screen is cleared.  Works for VT100
C
      CHARACTER*1 esc
      INTRINSIC CHAR
      esc = CHAR(27)
      WRITE (*,*) esc//'[2J'//esc//'[H'
      RETURN
      END
C
C
C
      INTEGER FUNCTION LENS(STRING)
C
C     Determine length of character string minus trailing blanks
C
      CHARACTER*(*) STRING
      INTEGER MAX, I
      INTRINSIC LEN
C
      MAX = LEN(STRING)
      DO 10 I = MAX, 1, -1
        IF (STRING(I:I).NE.' ') THEN
          LENS = I
          GOTO 20
        END IF
 10   CONTINUE
      LENS = 1
 20   RETURN
      END
